/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-15 at 20:00:32 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

/**
 * JSON template for Chrome Os Device resource in Apps Directory API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Admin Directory API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ChromeOsDevice extends com.google.api.client.json.GenericJson {

  /**
   * Address or location of the device as noted by the administrator
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String annotatedLocation;

  /**
   * User of the device
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String annotatedUser;

  /**
   * Chromebook boot mode (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String bootMode;

  /**
   * Unique identifier of Chrome OS Device (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String deviceId;

  /**
   * Chromebook firmware version (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String firmwareVersion;

  /**
   * Kind of resource this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Date and time the device was last enrolled (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime lastEnrollmentTime;

  /**
   * Date and time the device was last synchronized with the policy settings in the Google Apps
   * administrator control panel (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime lastSync;

  /**
   * Chromebook Mac Address (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String macAddress;

  /**
   * Mobile Equipment identifier for the 3G mobile card in the Chromebook (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String meid;

  /**
   * Chromebook Model (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String model;

  /**
   * Notes added by the administrator
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String notes;

  /**
   * Chromebook order number (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String orderNumber;

  /**
   * OrgUnit of the device
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String orgUnitPath;

  /**
   * Chromebook Os Version (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String osVersion;

  /**
   * Chromebook platform version (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String platformVersion;

  /**
   * Chromebook serial number (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String serialNumber;

  /**
   * status of the device (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String status;

  /**
   * Final date the device will be supported (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime supportEndDate;

  /**
   * Will Chromebook auto reniew after support end date (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean willAutoRenew;

  /**
   * Address or location of the device as noted by the administrator
   * @return value or {@code null} for none
   */
  public java.lang.String getAnnotatedLocation() {
    return annotatedLocation;
  }

  /**
   * Address or location of the device as noted by the administrator
   * @param annotatedLocation annotatedLocation or {@code null} for none
   */
  public ChromeOsDevice setAnnotatedLocation(java.lang.String annotatedLocation) {
    this.annotatedLocation = annotatedLocation;
    return this;
  }

  /**
   * User of the device
   * @return value or {@code null} for none
   */
  public java.lang.String getAnnotatedUser() {
    return annotatedUser;
  }

  /**
   * User of the device
   * @param annotatedUser annotatedUser or {@code null} for none
   */
  public ChromeOsDevice setAnnotatedUser(java.lang.String annotatedUser) {
    this.annotatedUser = annotatedUser;
    return this;
  }

  /**
   * Chromebook boot mode (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getBootMode() {
    return bootMode;
  }

  /**
   * Chromebook boot mode (Read-only)
   * @param bootMode bootMode or {@code null} for none
   */
  public ChromeOsDevice setBootMode(java.lang.String bootMode) {
    this.bootMode = bootMode;
    return this;
  }

  /**
   * Unique identifier of Chrome OS Device (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getDeviceId() {
    return deviceId;
  }

  /**
   * Unique identifier of Chrome OS Device (Read-only)
   * @param deviceId deviceId or {@code null} for none
   */
  public ChromeOsDevice setDeviceId(java.lang.String deviceId) {
    this.deviceId = deviceId;
    return this;
  }

  /**
   * Chromebook firmware version (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getFirmwareVersion() {
    return firmwareVersion;
  }

  /**
   * Chromebook firmware version (Read-only)
   * @param firmwareVersion firmwareVersion or {@code null} for none
   */
  public ChromeOsDevice setFirmwareVersion(java.lang.String firmwareVersion) {
    this.firmwareVersion = firmwareVersion;
    return this;
  }

  /**
   * Kind of resource this is.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is.
   * @param kind kind or {@code null} for none
   */
  public ChromeOsDevice setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Date and time the device was last enrolled (Read-only)
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getLastEnrollmentTime() {
    return lastEnrollmentTime;
  }

  /**
   * Date and time the device was last enrolled (Read-only)
   * @param lastEnrollmentTime lastEnrollmentTime or {@code null} for none
   */
  public ChromeOsDevice setLastEnrollmentTime(com.google.api.client.util.DateTime lastEnrollmentTime) {
    this.lastEnrollmentTime = lastEnrollmentTime;
    return this;
  }

  /**
   * Date and time the device was last synchronized with the policy settings in the Google Apps
   * administrator control panel (Read-only)
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getLastSync() {
    return lastSync;
  }

  /**
   * Date and time the device was last synchronized with the policy settings in the Google Apps
   * administrator control panel (Read-only)
   * @param lastSync lastSync or {@code null} for none
   */
  public ChromeOsDevice setLastSync(com.google.api.client.util.DateTime lastSync) {
    this.lastSync = lastSync;
    return this;
  }

  /**
   * Chromebook Mac Address (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getMacAddress() {
    return macAddress;
  }

  /**
   * Chromebook Mac Address (Read-only)
   * @param macAddress macAddress or {@code null} for none
   */
  public ChromeOsDevice setMacAddress(java.lang.String macAddress) {
    this.macAddress = macAddress;
    return this;
  }

  /**
   * Mobile Equipment identifier for the 3G mobile card in the Chromebook (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getMeid() {
    return meid;
  }

  /**
   * Mobile Equipment identifier for the 3G mobile card in the Chromebook (Read-only)
   * @param meid meid or {@code null} for none
   */
  public ChromeOsDevice setMeid(java.lang.String meid) {
    this.meid = meid;
    return this;
  }

  /**
   * Chromebook Model (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getModel() {
    return model;
  }

  /**
   * Chromebook Model (Read-only)
   * @param model model or {@code null} for none
   */
  public ChromeOsDevice setModel(java.lang.String model) {
    this.model = model;
    return this;
  }

  /**
   * Notes added by the administrator
   * @return value or {@code null} for none
   */
  public java.lang.String getNotes() {
    return notes;
  }

  /**
   * Notes added by the administrator
   * @param notes notes or {@code null} for none
   */
  public ChromeOsDevice setNotes(java.lang.String notes) {
    this.notes = notes;
    return this;
  }

  /**
   * Chromebook order number (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getOrderNumber() {
    return orderNumber;
  }

  /**
   * Chromebook order number (Read-only)
   * @param orderNumber orderNumber or {@code null} for none
   */
  public ChromeOsDevice setOrderNumber(java.lang.String orderNumber) {
    this.orderNumber = orderNumber;
    return this;
  }

  /**
   * OrgUnit of the device
   * @return value or {@code null} for none
   */
  public java.lang.String getOrgUnitPath() {
    return orgUnitPath;
  }

  /**
   * OrgUnit of the device
   * @param orgUnitPath orgUnitPath or {@code null} for none
   */
  public ChromeOsDevice setOrgUnitPath(java.lang.String orgUnitPath) {
    this.orgUnitPath = orgUnitPath;
    return this;
  }

  /**
   * Chromebook Os Version (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getOsVersion() {
    return osVersion;
  }

  /**
   * Chromebook Os Version (Read-only)
   * @param osVersion osVersion or {@code null} for none
   */
  public ChromeOsDevice setOsVersion(java.lang.String osVersion) {
    this.osVersion = osVersion;
    return this;
  }

  /**
   * Chromebook platform version (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getPlatformVersion() {
    return platformVersion;
  }

  /**
   * Chromebook platform version (Read-only)
   * @param platformVersion platformVersion or {@code null} for none
   */
  public ChromeOsDevice setPlatformVersion(java.lang.String platformVersion) {
    this.platformVersion = platformVersion;
    return this;
  }

  /**
   * Chromebook serial number (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getSerialNumber() {
    return serialNumber;
  }

  /**
   * Chromebook serial number (Read-only)
   * @param serialNumber serialNumber or {@code null} for none
   */
  public ChromeOsDevice setSerialNumber(java.lang.String serialNumber) {
    this.serialNumber = serialNumber;
    return this;
  }

  /**
   * status of the device (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getStatus() {
    return status;
  }

  /**
   * status of the device (Read-only)
   * @param status status or {@code null} for none
   */
  public ChromeOsDevice setStatus(java.lang.String status) {
    this.status = status;
    return this;
  }

  /**
   * Final date the device will be supported (Read-only)
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getSupportEndDate() {
    return supportEndDate;
  }

  /**
   * Final date the device will be supported (Read-only)
   * @param supportEndDate supportEndDate or {@code null} for none
   */
  public ChromeOsDevice setSupportEndDate(com.google.api.client.util.DateTime supportEndDate) {
    this.supportEndDate = supportEndDate;
    return this;
  }

  /**
   * Will Chromebook auto reniew after support end date (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getWillAutoRenew() {
    return willAutoRenew;
  }

  /**
   * Will Chromebook auto reniew after support end date (Read-only)
   * @param willAutoRenew willAutoRenew or {@code null} for none
   */
  public ChromeOsDevice setWillAutoRenew(java.lang.Boolean willAutoRenew) {
    this.willAutoRenew = willAutoRenew;
    return this;
  }

  @Override
  public ChromeOsDevice set(String fieldName, Object value) {
    return (ChromeOsDevice) super.set(fieldName, value);
  }

  @Override
  public ChromeOsDevice clone() {
    return (ChromeOsDevice) super.clone();
  }

}
